﻿# fuelle-tiefensuche-zwei-Kurs.py
# rekursives Programm zum Füllen eines Containers mit Tiefensuche


# Globale Variable für die Stücke:
stuecke=[30,30,30,30,20,20,20,20,20]
def erzeugeContainer(fassungsvermoegen):
    return [fassungsvermoegen, []]

def fuelleEin(stueck, container):
    inhalt=[]+container[1] # echte Kopie erzeugen!
    inhalt.append(stueck)
    return [container[0], inhalt]

# Prädikat zum Testen, ob der Container voll ist.
def istVoll(container):
    return container[0]==sum(container[1])

def alleVoll(containerListe):
    for container in containerListe:
        if not istVoll(container):
            return False
    return True

def istZuVoll(container):
    return container[0]<sum(container[1])

def einerZuVoll(containerListe):
    for container in containerListe:
        if istZuVoll(container):
            return True
    return False


def fuelle(stuecke, containerListe):
    ## zum Verfolgen des Ablaufs:
##    text='stuecke' + str(stuecke) +\
##          '\ncontainer_1' + str(container_1) +\
##          '\ncontainer_2' + str(container_2) + '\n'
    ##input(text)
    ##print(text)
    if alleVoll(containerListe):
        return containerListe
    if len(stuecke)==0:
        return False
    if einerZuVoll(containerListe):
        return False

    for i in range(len(containerListe)):
        ## mit dem Stück im jeweiligen Container versuchen
        ergebnis=fuelle(stuecke[1:],
                        containerListe[:i]+
                        [fuelleEin(stuecke[0], containerListe[i])]+
                        containerListe[i+1:])
        if ergebnis:
            return ergebnis
        ## auch ohne das Stück versuchen
    else:
        return fuelle(stuecke[1:], containerListe)


### Tests
def ausgabe(stuecke, fassungsvermoegen):
    containerListe=[]
    for i in range(3):
        containerListe.append(erzeugeContainer(fassungsvermoegen))
    print('Stücke:', stuecke*2, fassungsvermoegen,
          'Ergebnis:\n', fuelle(stuecke*2,
                                containerListe), '\n')


##ausgabe( stuecke, 80)
##ausgabe( stuecke, 90)
ausgabe( stuecke, 100)
##stuecke.reverse()
##print(stuecke)
##ausgabe( stuecke, 100)
##ausgabe( stuecke*10, 100)
##ausgabe( stuecke*10, 1000)
##ausgabe( [30,30,20,20], 50)
